/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.web.action;

import java.util.Map;

import jp.terasoluna.fw.service.thin.BLogicResult;
import jp.terasoluna.fw.web.struts.actions.AbstractBLogicAction;
import jp.terasoluna.thin.tutorial.service.blogic.ListBLogic;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * 一覧情報取得アクション。
 *
 * 一覧情報取得ビジネスロジックを呼び、一覧情報を取得する。
 *
 */
public class ListAction extends AbstractBLogicAction<Map<String, String>> {

    /**
     * ログクラス。
     */
    private Log log = LogFactory.getLog(ListAction.class);

    /**
     * 実行するビジネスロジッククラス。
     */
    private ListBLogic listBLogic = null;

    /**
     * ビジネスロジックを返却する。
     *
     * @return 保持するビジネスロジック
     */
    public ListBLogic getListBLogic() {
        return listBLogic;
    }

    /**
     * ビジネスロジックを設定する。
     *
     * @param listBLogic ビジネスロジック
     */
    public void setListBLogic(ListBLogic listBLogic) {
        this.listBLogic = listBLogic;
    }

    /**
     * ビジネスロジックを実行し、一覧情報を取得、返却する。
     *
     * @param map 一覧情報取得のための変数を保持したMap
     * @return 一覧情報を保持したBLogicResult
     * @throws Exception 例外
     */
    @Override
    public BLogicResult doExecuteBLogic(Map<String, String> map) 
        throws Exception {

        if (log.isDebugEnabled()) {
            log.debug("doExecuteBLogic Start.");
        }

        //ビジネスロジックの実行、結果の取得
        Map<String, Object> retMap = listBLogic.getUserList(map);

        //BLogicResultの生成、結果の設定
        BLogicResult result = new BLogicResult();
        result.setResultString("success");
        result.setResultObject(retMap);

        return result;
    }

}
